updates, especially for etiona
[distro-setup] / switch-mail-host
index e52abdb45326c9617697e591e7f5d9b3e62d1a9e..df0b83605ee25fc8c7743504d18a5698278a2916 100644 (file)
@@ -1,54 +1,10 @@
 #!/bin/bash
 
-err-bash-trace() {
-  local -i argc_index=0 frame i start=${1:-0} max_indent=8 indent
-  local source
-  local extdebug=false
-  if [[ $(shopt -p extdebug) == *-s* ]]; then
-    extdebug=true
-  fi
-  for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
-    argc=${BASH_ARGC[frame]}
-    argc_index+=$argc
-    ((frame < start)) && continue
-    if (( ${#BASH_SOURCE[@]} > 1 )); then
-      source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
-    fi
-    indent=$((frame-start + 1))
-    indent=$((indent < max_indent ? indent : max_indent))
-    printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
-    if $extdebug; then
-      for ((i=argc_index-1; i >= argc_index-argc; i--)); do
-        printf " %s" "${BASH_ARGV[i]}"
-      done
-    fi
-    echo \'
-  done
-  return 0
-}
-
-
-err-catch() {
-  set -E; shopt -s extdebug
-  _err-trap() {
-    err=$?
-    exec >&2
-    set +x
-    echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
-    err-bash-trace 2
-    set -e # err trap does not work within an error trap
-    "${_errcatch_cleanup[@]:-:}" # note :-: is to be compatible with set -u
-    echo "$0: exiting with code $err"
-    exit $err
-  }
-  trap _err-trap ERR
-  set -o pipefail
-}
-err-catch
+source /usr/local/lib/err
 
 usage() {
   cat <<EOF
-Usage: ${0##*/} OLD_HOST NEW_HOST
+Usage: ${0##*/} push|pull HOST
 
 Turn off mail receiving on OLD_HOST, run btrbk to move mail to NEW_HOST,
 turn on mail receiving on NEW_HOST.  Assumes we want to move all
@@ -68,72 +24,84 @@ EOF
 
 restore_new_btrbk=false
 restore_old_btrbk=false
-cleanup() {
+err-cleanup() {
   if $restore_new_btrbk; then
-    $new_shell sudo systemctl start btrbk.timer
+    e WARNING: due to failure, btrbk.timer may need manual restoration:
+    e $new_shell sudo systemctl start btrbk.timer
   fi
   if $restore_old_btrbk; then
-    $old_shell sudo systemctl start btrbk.timer
+    e WARNING: due to failure, btrbk.timer may need manual restoration:
+    e $old_shell sudo systemctl start btrbk.timer
   fi
 }
-_errcatch_cleanup=cleanup
 
 pre="${0##*/}:"
 m() { printf "$pre %s\n"  "$*"; "$@"; }
 e() { printf "$pre %s\n"  "$*"; }
+err() { echo "$pre ERROR: $*" >&2; }
+mexit() { echo "$pre exiting with status $1"; exit $1; }
 
 ##### begin command line parsing ########
 
-temp=$(getopt -l help owh "$@") || usage 1
+force=false
 mp_args="-m /o,/q,/a"
+temp=$(getopt -l force,help owh "$@") || usage 1
 eval set -- "$temp"
 while true; do
   case $1 in
+    --force) force=true ;;
     -o) mp_args="-m /o"; shift ;;
     -h|--help) usage ;;
     --) shift; break ;;
-    *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
+    *) echo "$0: Internal error! unexpected args: $*" ; mexit 1 ;;
   esac
 done
 
 
 (( $# == 2 )) || usage 1
 
-old_host=$1
-new_host=$2
-source /a/bin/bash_unpublished/source-state
-
-if [[ $old_host != $MAIL_HOST ]]; then
-  read -p "warning: \$old_host != \$MAIL_HOST: $old_host != $MAIL_HOST, proceed? y/N "
-  if [[ $REPLY != [yY] ]]; then
-    exit 1
-  fi
+if [[ ! $HOSTNAME ]]; then
+  err '$HOSTNAME is unset'
+  mexit 1
 fi
 
-if [[ $new_host == "$HOSTNAME" ]]; then
-  localhost_new=true
-  new_shell=
-else
-  localhost_new=false
-  new_shell="ssh $new_host"
-fi
+case $1 in
+  push)
+    old_host=$HOSTNAME
+    old_hostname=$HOSTNAME
+    new_host=$2
+    bbk_args="-t $new_host"
+    new_shell="ssh $new_host"
+    new_hostname=$($new_shell hostname)
+    ;;
+  pull)
+    old_host=$2
+    new_host=$HOSTNAME
+    new_hostname=$HOSTNAME
+    bbk_args="-s $old_host"
+    old_shell="ssh $old_host"
+    # tests ssh connection
+    old_hostname=$($old_shell hostname)
+    ;;
+  *)
+    err invalid first argument
+    mexit 1
+    ;;
+esac
 
-old_shell="ssh $old_host"
-if [[ $old_host == "$HOSTNAME" ]]; then
-  old_shell=
+source /a/bin/bash_unpublished/source-state
+
+if [[ $old_hostname != "$MAIL_HOST" ]] && ! $force; then
+  err "\$old_hostname($old_hostname) != \$MAIL_HOST($MAIL_HOST). Rerun with --force if you really want this."
+  mexit 1
 fi
 
 if [[ ! $new_host || ! $old_host ]]; then
   echo "$0: bad args. see script"
-  exit 1
+  mexit 1
 fi
 
 
-source /a/bin/bash_unpublished/source-state
-
-
-new_hostname=$($new_shell hostname)
-
 ########### end initial processing, begin actually modifying things ##########
 
 if $new_shell systemctl is-active btrbk.timer; then
@@ -146,11 +114,24 @@ if $old_shell systemctl is-active btrbk.timer; then
 fi
 
 btrbk_test="systemctl is-active btrbk.service"
-while [[ $($new_shell $btrbk_test) != inactive ]] || [[ $($old_shell $btrbk_test) != inactive ]]; do
-  echo "$0: btrbk is running on new or old host. sleeping for 8 seconds"
-  sleep 6
-  echo "$0: testing for btrbk activity in 2 seconds"
-  sleep 2
+active=true
+while $active; do
+  active=false
+  for shell in "$new_shell" "$old_shell"; do
+    e $shell $btrbk_test
+    status=$($shell $btrbk_test) ||:
+    case $status in
+      inactive|failed) : ;;
+      *)
+        # This covers conditions like "activating", which still return 3 from
+        # systemctl is-active.
+        active=true
+        e "btrbk active on shell:$shell, status:$status, sleeping 8 seconds"
+        sleep 8
+        break
+        ;;
+    esac
+  done
 done
 
 # ensure these are unused before doing anything
@@ -176,12 +157,25 @@ EOF
 # I think exim will try ipv6 first, so no need to disable
 # ipv6 i think.
 
+
+e Running initial btrbk
+if ! m btrbk-run -v $bbk_args $mp_args; then
+  ret=$?
+  err "failed initial btrbk"
+  mexit $ret
+fi
+
 m $old_shell /a/exe/primary-setup $new_hostname
 
-if $localhost_new; then
-  m btrbk-run -v -s $old_host $mp_args
-else
-  m btrbk-run -v -t $new_host $mp_args
+e Running main btrbk
+m btrbk-run -v $bbk_args -m /o || ret=$?
+if (( ret )); then
+  bang="$(printf "$(tput setaf 5)█$(tput sgr0)%.0s" 1 2 3 4 5 6 7)"
+  e $bang failed btrbk of /o. restoring old host as primary
+  m $old_shell /a/exe/primary-setup localhost
+  mexit $ret
 fi
 
-m $new_shell /a/exe/primary-setup $new_hostname
+m $new_shell /a/exe/primary-setup localhost
+
+mexit 0